
package de.ivu.elect.presentation.ergebnis;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisBoundaryCreate;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebnis.entity.ErgebnisMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractErgebnisCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractErgebnisCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.ERGEBNIS_CREATE)
public abstract class AbstractErgebnisCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Ergebnis> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisCreateView";

  public static final String VIEW_ID = "/ergebnis/ergebnis-create.xhtml";

  public static final String PARENT_VIEW_ID = "/ergebnis/ergebnis-search.xhtml";

  @Inject
  protected transient ErgebnisBoundaryCreate create;

  protected Ergebnis entity;

  @Inject
  protected transient ErgebnisMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Ergebnis());
  }

  

  public Ergebnis getEntity() {
    return entity;
  }

  protected void setEntity(Ergebnis entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERGEBNIS_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Ergebnis entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Ergebnis entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.ERGEBNIS_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
